let numberS = 400;
let rMax=10;
let sterren = new Array(numberS);

function setup() {
  createCanvas(400,300);
  background(0);
  noStroke();
  for (let i = 0; i < numberS; i++){
    sterren[i] = new Ster(random(width), random(height), random(rMax));
    sterren[i].reset(); //eventueel begin je met een reset (alles transparant)
  }
}
function draw(){
  background(0);
  for (let i = 0; i < numberS; i++){
    sterren[i].show();
  }
}
// class
function Ster(cX,cY, r){
  this.cX = cX;
  this.cY = cY;
  this.r = r;
  this.transp = r/rMax * 255;
  this.show = function (){
    // afstand tot het midden wordt gedeeld en erbij geteld:
    this.cX += ((this.cX - width/2)/100)*(this.r/rMax);
    this.cY += ((this.cY-height/2)/100)*(this.r/rMax);
    if ( this.cX < -this.r || this.cX > width || this.cY > height || this.cY < -this.r){
      this.reset();
    }
    // de transparantie wordt telkens groter
    if (this.transp < 255){
      this.transp += (this.r/rMax)*5;
    }
    this.r += (this.r/rMax)/40;
    fill (255,255,255,this.transp);
    ellipse(this.cX, this.cY, this.r, this.r);
  }
  this.reset = function (){
    this.cY = random(width);
    this.cX = random(height);
    this.r = random(rMax)/2;
    this.transp = 0;
  }
}
